﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default"
    EnableSessionState="True" %>

<%@ Register Assembly="C1.Web.Wijmo.Controls.4" Namespace="C1.Web.Wijmo.Controls.C1Upload"
    TagPrefix="wijmo" %>
<%@ Register Assembly="C1.Web.Wijmo.Controls.4" Namespace="C1.Web.Wijmo.Controls.C1TreeView"
    TagPrefix="wijmo" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <!--jQuery References-->
    <script src="http://code.jquery.com/jquery-1.8.2.min.js" type="text/javascript"></script>
    <script src="http://code.jquery.com/ui/1.9.1/jquery-ui.min.js" type="text/javascript"></script>
    <script type="text/javascript">

        $(document).ready(function () {
            ////--------------------------------------------------------------------------------------------------
            //ADD ROOT Node or New Folder
            $("#btnAddRoot").click(function () {
                //add node to tree
                $("#C1TreeView1").c1treeview("add", "New Folder", 0);
                var nodes = $("#C1TreeView1").c1treeview("getNodes");
                //set new nodes peroperties
                $(nodes[0].element).c1treeviewnode("option", {
                    collapsedIconClass: "ui-icon-folder-collapsed",
                    expandedIconClass: "ui-icon-folder-open",
                    itemIconClass: "ui-icon-document",
                    selected: true
                });

                var folderName = selectedPath;
                //call to server side to create corresponding folder
                $.ajax({
                    type: "POST",
                    url: "./Default.aspx/CreateRoot",
                    data: "{folderName:'" + folderName + "'}",
                    async: true,
                    cache: false,
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: function (msg) {
                        //set node text based on physical folder created
                        $(nodes[0].element).c1treeviewnode("option", "text", msg.d);
                    },
                    error: function (err) {
                        alert(error);
                    }
                });
                return false;
            });

            ////--------------------------------------------------------------------------------------------------
            //ADD SUBFOLDER or ChildNode
            $("#btnAddChild").click(function () {
                //get the selected node to create its child node
                var selectedNodes = $("#C1TreeView1").c1treeview("getSelectedNodes"), selectedNode;
                //add new node to the tree if a node is selected.
                if (selectedNodes.length > 0) {
                    //check if selected node is a file or a folder
                    var ele = selectedPath.split("\\").pop();
                    if (ele.split(".").length > 1) {
                        alert("This is a file, can't create its subfolder.");
                    }
                    //if selected node is a folder
                    else {
                        selectedNode = $(selectedNodes[0].element);
                        selectedNode.c1treeviewnode("add", "New Folder", 0);
                        selectedNode.c1treeviewnode("option", {
                            expanded: true,
                            selected: false
                        });

                        var childNodes = selectedNode.c1treeviewnode("getNodes");
                        //set properties of child node
                        $(childNodes[0].element).c1treeviewnode("option", {
                            collapsedIconClass: "ui-icon-folder-collapsed",
                            expandedIconClass: "ui-icon-folder-open",
                            itemIconClass: "ui-icon-document",
                            selected: true
                        });
                        //get path of child node to pass to server
                        var path = selectedPath;
                        //pass path to server side.
                        $.ajax({
                            type: "POST",
                            url: "./Default.aspx/CreateSubFolder",
                            data: "{path:'" + path + "'}",
                            async: true,
                            cache: false,
                            contentType: "application/json; charset=utf-8",
                            dataType: "json",
                            success: function (msg) {
                                //set node text based on physical folder created
                                $(childNodes[0].element).c1treeviewnode("option", "text", msg.d);
                            },
                            error: function (err) {
                                alert(error);
                            }
                        });
                    }

                }
                else {
                    alert("Select a parent folder first..!!");
                }

                return false;
            });
            ////--------------------------------------------------------------------------------------------------
            //DELETE a node or folder
            $("#btnDelete").click(function () {
                //get selected node to delete
                var selectedNodes = $("#C1TreeView1").c1treeview("getSelectedNodes");

                //if a node is selected, delete it.
                if (selectedNodes.length > 0) {
                    var text = $(selectedNodes[0].element).c1treeviewnode("option", "text");
                    //get owner of node to be deleted.
                    var owner = $(selectedNodes[0].element).c1treeviewnode("getOwner");

                    if (owner != null) {
                        //get index based on ownwer node if node is not a root node
                        var nodes = owner.getNodes();
                        $(nodes).each(function (element, index) {
                            if ($(this)[0]._text == text) {
                                $(owner)[0].remove($(this)[0]._index);
                            }
                        });
                    } else {
                        //get index if node is a root node of the tree
                        var nodes = $("#C1TreeView1").c1treeview("getNodes");
                        $(nodes).each(function (index, element) {
                            if ($(this)[0]._text == text) {
                                $("#C1TreeView1").c1treeview("remove", index);
                            }
                        });
                    }
                    //get Selected Node's path
                    var path = selectedPath;
                    //call to server side to delete selected node/folder
                    $.ajax({
                        type: "POST",
                        url: "./Default.aspx/DeleteNode",
                        data: "{path:'" + path + "'}",
                        async: true,
                        cache: false,
                        contentType: "application/json; charset=utf-8",
                        dataType: "json",
                        success: function (msg) {

                        },
                        error: function (err) {
                            alert(error);
                        }
                    });
                } else {
                    alert("Select a folder to delete..!!");
                }
                return false;
            });

            ////--------------------------------------------------------------------------------------------------
            //RENAME A NODE
            var nodeElementSpan;
            var pathOfNode = "";
            $("#btnRename").click(function () {
                if ($(nodeElementSpan).length == 0) {
                    alert("Select a Folder or File to rename.");
                }
                else {
                    $(nodeElementSpan).click();
                }

                return false;
            });
            var selectedPath = "";
            $("#C1TreeView1").c1treeview({
                //event to get variable "selectedpath", raised everytime a new node is selected
                selectedNodeChanged: function (e, data) {
                    selectedPath = data._text;
                    var owner = $(data.element).c1treeviewnode('getOwner');
                    var currentLevel = 0;
                    if (owner == null) {
                        selectedPath = data._text;
                        currentLevel = 0;
                    }
                    else {
                        selectedPath = data._text;
                        currentLevel = $(data.element).c1treeviewnode('getOwner')._getCurrentLevel();
                        var node = $(data.element).c1treeviewnode('getOwner');
                        while (currentLevel >= 0) {

                            selectedPath = $($(node)[0].element).c1treeviewnode("option", "text") + "\\\\" + selectedPath;
                            node = $($(node)[0].element).c1treeviewnode('getOwner');
                            if (node == null)
                                break;
                            currentLevel--;
                        }
                    }

                },
                nodeClick: function (e, data) {
                    nodeElementSpan = data.$inner.find('span :eq(1)');
                },
                //event to handle renaming a node.
                nodeTextChanged: function (e, data) {
                    //check if node text has been changed
                    if (data._text != data.options.text) {
                        //get new name
                        var newFolderName = data.options.text;
                        //get path of child node to pass to server
                        var owner = $(data.element).c1treeviewnode('getOwner');
                        var currentLevel = 0;
                        if (owner == null) {
                            pathOfNode = data._text;
                            currentLevel = 0;
                        }
                        else {
                            pathOfNode = data._text;
                            currentLevel = $(data.element).c1treeviewnode('getOwner')._getCurrentLevel();
                            var node = $(data.element).c1treeviewnode('getOwner');
                            while (currentLevel >= 0) {

                                pathOfNode = $($(node)[0].element).c1treeviewnode("option", "text") + "\\\\" + pathOfNode;
                                node = $($(node)[0].element).c1treeviewnode('getOwner');
                                if (node == null)
                                    break;
                                currentLevel--;
                            }
                        }
                        //pass path of node and new pathname to server
                        $.ajax({
                            type: "POST",
                            url: "./Default.aspx/RenameNode",
                            data: "{path:'" + pathOfNode + "', newName:'" + newFolderName + "'}",
                            async: true,
                            cache: false,
                            contentType: "application/json; charset=utf-8",
                            dataType: "json",
                            success: function (msg) {

                            },
                            error: function (err) {
                                alert(error);
                            }
                        });
                    }
                }
            });
            ////--------------------------------------------------------------------------------------------------
            //Handling Upload event of C1Upload.
            $("#C1Upload1").c1upload({
                //1. upload event is raised once the upload button of a file is clicked.
                upload: function (e, data) {
                    var filename = data[0].value;
                    var arr = filename.split("\\");
                    filename = arr[arr.length - 1];
                    var selectedNodes = $("#C1TreeView1").c1treeview("getSelectedNodes");
                    if (selectedNodes.length > 0) {
                        //check if selected node is a file or a folder
                        var ele = selectedPath.split("\\").pop();
                        if (ele.split(".").length > 1) {
                            alert("this is a file, can't upload file under it.");
                        }
                        //if selected node is a folder
                        else {
                            $(selectedNodes[0].element).c1treeviewnode("add", filename, 0);
                            $(selectedNodes[0].element).c1treeviewnode({ expanded: true, selected: false });
                            var childNodes = $(selectedNodes[0].element).c1treeviewnode("getNodes");
                            $(childNodes[0].element).c1treeviewnode({
                                itemIconClass: "ui-icon-document",
                                selected: true
                            });

                            var path = selectedPath;
                            CallTheServer(path, '');   //2. Server side RaiseCallbackEvent method is called
                        }

                    }
                    else {
                        alert("Select the target folder..!!");
                    }


                }
            });
        });
        //5.
        function ReceiveServerData(arg, context) {
          
        }

    </script>
</head>
<body>
    <form id="form1" runat="server">
    <table>
        <tr>
            <td>
                <asp:Button ID="btnAddRoot" runat="server" Text="Add Root" />
                <asp:Button ID="btnAddChild" runat="server" Text="Add SubFolder" />
                <asp:Button ID="btnDelete" runat="server" Text="Delete" />
                <asp:Button ID="btnRename" runat="server" Text="Rename" />
            </td>
            <td>
                <wijmo:C1Upload ID="C1Upload1" runat="server" Width="300px" TargetFolder="~/TargetFolder"
                    OnValidatingFile="C1Upload1_ValidatingFile" />
            </td>
        </tr>
    </table>
    <wijmo:C1TreeView ID="C1TreeView1" runat="server" AllowDrag="true" AllowDrop="true"
        AllowEdit="true" AllowSorting="true">
    </wijmo:C1TreeView>
    <asp:HiddenField ID="hdnSubfolderPath" runat="server" />
    <asp:HiddenField ID="hdnDeleteFolderPath" runat="server" />
    <asp:HiddenField ID="hdnTargetFolderPath" runat="server" />
    </form>
</body>
</html>
